<template>
  <div class="contSecc">
    <div class="titulo">
      <link
        rel="stylesheet"
        href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css"
        integrity="sha384-9aIt2nRpC12Uk9gS9baDl411NQApFmC26EwAOH8WgZl5MYYxFfc+NcPb1dKGj7Sk"
        crossorigin="anonymous"
      />
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs" :large="false">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Detalle Día Supervisor</strong>
    </div>

    <v-parallax
      src="https://vuetifyjs.com/static/doc-images/parallax/material2.jpg"
      height="100vh"
    >
      <v-layout row wrap align-center justify-center>
        <v-flex xs6 offset xs-1 sm6 offset-sm1 md6 offset-md1>
          <v-card class="elevation-2 cardTitDetalle">
            <v-card-title primary-title class="layout justify-center">
              <h4>Detalle Día Supervisor</h4>
            </v-card-title>
            <v-card-text>
              <v-row outlined dense>
                <v-col cols="3">
                  Supervisor:
                </v-col>
                <v-col cols="9">
                  <strong> {{ this.nombreUsuario }} </strong> ({{
                    this.idUsuario
                  }})
                </v-col>
              </v-row>
              <v-row outlined dense>
                <v-col cols="3">
                  Fecha:
                </v-col>
                <v-col cols="9">
                  <strong>{{ this.fechaSQ }}<br /></strong>
                </v-col>
              </v-row>
              <v-row outlined dense>
                <v-col cols="3">
                  Semana:
                </v-col>
                <v-col cols="9">
                  <strong>{{ this.semana }}<br /></strong>
                </v-col>
              </v-row>
            </v-card-text>
          </v-card>
        </v-flex>
      </v-layout>
    </v-parallax>

    <div class="contSecc">
      <!--  termina parametrizado-->

      <!--      LISTA   del   DETALLE     -->
      <div class="gris">
        <div class="contSecc">
          <div class="divBuscador">
            <div class="padding">
              <v-text-field
                v-model="search"
                class="buscador"
                append-icon="mdi-magnify"
                label="Buscar..."
                clearable
                single-line
                hide-details
              ></v-text-field>
            </div>
          </div>

          <!--  tabla-->
          <v-data-table
            :headers="encabezadoTareas"
            :items="tareasRealizadas"
            :page.sync="page"
            :items-per-page="itemsPerPage"
            @page-count="pageCount = $event"
            :search="search"
            class="tblGeneral tblReporte"
          >
            <template v-slot:item.lnkDetalle_="{ item }">
              <a :href="getLinkToModulo(item)">
                Detalle
              </a>
            </template>
          </v-data-table>
          <!-- termina  tabla-->
        </div>
      </div>

      <div style="margin: 25px 10px 50px 10px">
        <v-btn
          color="primary"
          dark
          @click="downExcel()"
          :disabled="disabledBtnDownload"
          class="btnDisabled"
        >
          <strong style="fond-size : 16px; color:  #000;"
            >Descargar a Excel</strong
          >
        </v-btn>
      </div>

      <!-- Dialog dialogFechasNulas  -->
      <v-dialog v-model="dialogFechasNulas" max-width="600" persistent>
        <v-card class="padding">
          <v-card-title class="headline">
            <div class="titModal">
              <div><strong>No se cargo Informacion</strong></div>
            </div>
          </v-card-title>
          <div class="contModal tCenter">
            <div>
              Te Falta llenar Datos De busqueda
            </div>
          </div>
          <div class="btnCenter">
            <v-btn color="primary" dark @click="dialogFechasNulas = false">
              <strong style="fond-size : 16px; color:  #000;"
                >¡De acuerdo!</strong
              >
            </v-btn>
          </div>
        </v-card>
      </v-dialog>
    </div>

    <v-dialog v-model="dlgMensaje" persistent max-width="600px">
      <v-card>
        <div class="gris">
          <v-card-title class="headline">
            <div class="titModal">
              <div>
                <strong> {{ titMensaje }}</strong>
              </div>
            </div>
          </v-card-title>
          <div class="contModal tCenter">
            <strong> {{ txtMensaje }}</strong>
          </div>
          <br />
          <div class="tCenter">
            <v-btn color="primary" dark @click="dlgMensaje = false">
              <strong style="fond-size : 16px; color:  #000;">OK</strong>
            </v-btn>
          </div>
        </div>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import router from "@/router";
import FileSaver from "file-saver";
import store from "@/store";
const axiosChecklist = store.state.axiosChecklist;
import axios from "axios";
const serviceCommons = store.state.serviceCommons;

import moment from "moment";

export default {
  name:
    "supervision_mantenimiento_asignaciones_reportes_asistencia_mantenimiento",

  data() {
    return {
      //calendario
      menu: false,
      modal: false,
      menu1: false,
      menu2: false,

      dateSQ: "",
      semana: "",
      idUsuario: "",
      //  Params para regresar a Segundo Nivel
      paramsNivel_2: "",
      fechaInicio: "",
      fechaFin: "",
      idTerritorio: "",
      territorio: "",
      responsable: "",
      valueTrimestre: "",
      targetTrimestre: "",
      valueAldia: "",
      targetAldia: "",
      rangoSemanas: "",
      rangos: "",
      //dialogs
      dialogFechasNulas: false,
      disabledBtnBuscar: true,
      disabledBtnDownload: true,
      //   DIALOGS
      dlgMensaje: false,
      titMensaje: "",
      txtMensaje: "",
      idLocStoragePrev: "",
      tareasRealizadas: [],
      //pagina
      pageCount: 1,
      page: 1,
      itemsPerPage: 20,
      search: "",
      propiedades_footer: {
        itemsPerPageOptions: [2, 4, 5, 10],
        //habilita botones
        habilitaFechaFin: true,
      },
      encabezadoTareas: [
        { text: "ID Ceco", value: "idCeco", align: "center" },
        { text: "CECO", value: "nombreCeco", align: "center" },
        { text: "ID Fase", value: "idFase", align: "center" },
        { text: "Nombre Fase", value: "nombreFase", align: "center" },
        { text: "Hora Entrada", value: "horaEntrada", align: "center" },
        { text: "Hora Salida", value: "horaSalida", align: "center" },
        //{ text: "Salida Protocolo",     value: "horaSalidaProtocolo",align: "center"   },
        { text: "Horas Trabajadas", value: "horasTrabajadas", align: "center" },
        //{ text: "Módulos Contestados",  value: "totalModulos",       align: "center"   },
        { text: "Detalle", value: "lnkDetalle_", align: "center" },
      ],
      // metadata: {
      //     usuarios: [],
      // },
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Supervisión Mantenimiento",
          disabled: false,
          exact: true,
          to: {
            name: "supervision_mantenimiento_asignaciones_home",
          },
        },
        {
          text: "Dashboard Supervisión Mantenimiento",
          disabled: false,
          exact: true,
          to: {
            name:
              "supervision_mantenimiento_dashboard_primer_nivel_mantenimiento_supervision",
          },
        },
        {
          text: "Dashboard Supervisión Mantenimiento Territorio",
          disabled: true,
          to: {
            name: "supervision_mantenimiento_dashboard_segundo_nivel",
            params: {
              responsable: this.responsable,
              territorio: this.territorio,
              idTerritorio: this.idTerritorio,
              fechaInicio: this.fechaInicio,
              fechaFin: this.fechaFin,
              valueTrimestre: this.valueTrimestre,
              targetTrimestre: this.targetTrimestre,
              valueAldia: this.valueAldia,
              targetAldia: this.targetAldia,
              rangoSemanas: this.rangoSemanas,
              rangos: this.rangos,
              paramsNivel_2: this.paramsNivel_2,
            },
          },
        },
        {
          text: "Detalle Semana Supervisor",
          disabled: true,
          to: {
            name:
              "supervision_mantenimiento_asignaciones_reportes_asistencia_mantenimiento_lista",
          },
        },
        {
          text: "Detalle Día Supervisor",
          disabled: true,
        },
      ],
    };
  },
  beforeCreate() {
    //this.paramsNivel_2 = this.$route.query.paramsNivel_2
    this.paramsNivel_2 = this.serviceCommons.base64ToObject(
      this.$route.query.parametros
    ).paramsNivel_2;

    if (this.paramsNivel_2) {
      let parmsJson = JSON.parse(this.paramsNivel_2);

      this.fechaInicio = parmsJson.fechaInicio;
      this.fechaFin = parmsJson.fechaFin;
      this.idTerritorio = parmsJson.idTerritorio;
      this.territorio = parmsJson.territorio;
      this.responsable = parmsJson.responsable;
      this.valueTrimestre = parmsJson.valueTrimestre;
      this.targetTrimestre = parmsJson.targetTrimestre;
      this.valueAldia = parmsJson.valueAldia;
      this.targetAldia = parmsJson.targetAldia;
      this.rangoSemanas = parmsJson.rangoSemanas;
      this.rangos = parmsJson.rangos;
      console.log("BEFORE CREATE DETALLE: " + this.paramsNivel_2);
    }
  },
  created() {
    let parametros = this.serviceCommons.base64ToObject(
      this.$route.query.parametros
    );
    //this.paramsNivel_2 = this.$route.query.paramsNivel_2
    this.paramsNivel_2 = parametros.paramsNivel_2;

    this.limpiaFormulario();
    this.semana = parametros.semana;
    this.fechaSQ = parametros.fechaSQ;
    this.idUsuario = parametros.idUsuario;
    this.nombreUsuario = parametros.nombreUsuario;
    /*
        this.semana = this.$route.query.semana
        this.fechaSQ = this.$route.query.fechaSQ
        this.idUsuario = this.$route.query.idUsuario
        this.nombreUsuario = this.$route.query.nombreUsuario
        */

    //console.log('Fecha Undefined:' + (typeof(this.fechaSQ) == 'undefined'))

    if (typeof this.fechaSQ == "undefined") {
      this.alerta(
        "Error en Parámetros",
        "Sin datos suficientes para generar nueva información"
      );
    } else {
      this.srvGetDetalle();
    }
  },
  methods: {
    verifDates() {
      const [yrI, mesI, diaI] = this.date.split("-");
      const [yrF, mesF, diaF] = this.date1.split("-");

      var dtIni = new Date(yrI, mesI - 1, diaI);
      var dtFin = new Date(yrF, mesF - 1, diaF);
      var hoy = new Date();

      if (dtFin < dtIni) {
        this.alerta(
          "Error en Fechas",
          "La fecha fin no puede ser menor a la fecha de inicio"
        );
        return false;
      }

      if (dtFin > hoy) {
        console.log("huich");
        this.alerta(
          "Error en Fecha",
          "La fecha fin no puede ser mayor a la fecha actual"
        );
        return false;
      }
      // Fechas OK
      return true;
    },
    /*
        hayStorage(){
            let listaSupervs = JSON.parse(localStorage.getItem("LS_Supervs"));

            if(listaSupervs == null){
                return false
            }
            else{
                this.tareasRealizadas = listaSupervs
                this.date = localStorage.getItem("fechaIniLS")
                this.date1 = localStorage.getItem("fechaFinLS")
                this.disabledBtnDownload = false;
                this.disabledBtnBuscar = false
                //console.log('Existe Local Storage:' + '|' + this.date + '|' + this.date1)
                return true
            }
        },
        */
    srvGetDetalle() {
      let fechaSQL = this.fechaSQ.replaceAll("/", "");

      if (fechaSQL.length != 6) {
        this.alerta(
          "Error en Fecha",
          "Se detectó un error en la fecha: " + this.fechaSQ
        );
        return;
      }

      let fechaInicio_ = fechaSQL;
      let idUsuario_ = this.idUsuario;

      this.objAdd = {
        fechaInicio: fechaInicio_, //this.$route.query.fecha,
        idUsuario: idUsuario_,
      };

      console.log(
        "calling[asignacion-mtto/secure/get/reporteCheckInn]:" +
          fechaInicio_ +
          "|" +
          idUsuario_
      );

      axios
        .post("asignacion-mtto/secure/get/reporteCheckInn", this.objAdd)
        .then((response) => {
          if (response) {
            if (response.status === 200) {
              if (typeof response.data.data == "undefined") {
                this.alerta(
                  "Sin Registros",
                  "No se obtuvieron registros del usuario: " +
                    this.idUsuario +
                    ", para la fecha: " +
                    this.fechaSQ
                );
                return;
              }
              this.tareasRealizadas = response.data.data;
              this.limpiaFormulario();
              this.disabledBtnDownload = false;
              console.log(
                "response.data.data:" + JSON.stringify(response.data.data)
              );
            } else {
              this.dialogFechasNulas = true;
            }
          }
        })
        .catch((error) => {
          console.log("ERROR:" + error);
        })
        .finally(function() {});
    },
    crearInfoExcel() {
      let datos = this.tareasRealizadas;
      let xlsInfo = [];
      let fields = [
        //  0-Header Excel    1-Dato desde DB
        ["ID_ceco", "idCeco"],
        ["CECO", "nombreCeco"],
        ["ID_Fase", "idFase"],
        ["Nombre_Fase", "nombreFase"],
        ["Hora_Entrada", "horaEntrada"],
        ["Hora_Salida", "horaSalida"],
        ["Horas_Trabajadas", "horasTrabajadas"],
      ];
      for (var i = 0; i < datos.length; i++) {
        let ass = new Object();
        for (var j = 0; j < fields.length; j++) {
          let instrucc =
            "ass." +
            fields[j][0] +
            " = typeof(datos[i]." +
            fields[j][1] +
            ") == 'undefined' ? '' : " +
            "datos[i]." +
            fields[j][1];
          eval(instrucc);
        }
        xlsInfo.push(ass);
      }
      return xlsInfo;
    },
    downExcel() {
      //const dataFinal = this.tareasRealizadas;
      const dataFinal = this.crearInfoExcel();
      console.log("Rows xls:" + dataFinal.length);

      axios({
        method: "post",
        url: "/json/convert/secure/array/excel",
        responseType: "blob",
        data: dataFinal,
      })
        .then((response) => {
          if (response.headers["content-type"] !== "application/json") {
            FileSaver.saveAs(response.data, response.headers["file-name"]);
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    limpiaFormulario() {
      //this.date = "";
      //this.date1 = "";
      //this.menu2 = "";
      //this.menu = "";
      //this.usuarioEncontrado = "";
      //this.cecoSeleccionado = "";
      //this.listaTipoNego = "";
      //this.metadata.cecos = [];
      //this.metadata.negocios = [];
      //this.metadata.usuarios = [];
      //this.metadata.gerentes = [];
      //this.dateFormatted = "";
      //this.picker = "";
      //this.comentario = "";
      //this.dialogConfimacionActualiza = false;
    },
    formatDate(date) {
      if (!date) return null;

      const [year, month, day] = date.split("-");
      return `${month}/${day}/${year}`;
    },
    alerta(titulo, mensaje) {
      this.titMensaje = titulo;
      this.txtMensaje = mensaje;
      this.dlgMensaje = true;
    },
    getLinkToModulo(item) {
      let parametros = this.serviceCommons.objectToBase64({
        fechaSQ: this.fechaSQ,
        idUsuario: this.idUsuario,
        nombreUsuario: this.nombreUsuario,
        semana: this.semana,
        fase: item.idFase,
        ceco: item.idCeco,
        nombreFase: item.nombreFase,
        paramsNivel_2: this.paramsNivel_2,
      });
      console.log("Link a Modulo:" + this.paramsNivel_2);

      return "asistencia-mantenimiento-modulo?parametros=" + parametros;
    },
  }, // fin metodos
  computed: {
    computedDateFormatted() {
      return this.formatDate(this.date);
    },
    serviceCommons() {
      return serviceCommons;
    },
  },
  watch: {
    date(val) {
      this.dateFormatted = this.formatDate(this.date);
    },
    // date2(val) {
    //     this.dateFormatted2 = this.formatDate(this.date);
    // }
  },
};
</script>

<style>
.padding {
  padding-bottom: 25px;
}
.btnDisabled {
  color: gray;
  border: 1px solid #f7b851;
}
.parrafoCentrado {
  text-align: center;
}
.parallax {
  min-height: 100vh;
  display: flex;
  align-items: center;
}
.card__text {
  font-size: 1.2em;
  padding-top: 0;
  padding-bottom: 7%;
}
.cardTitDetalle {
  margin: 20px;
  max-width: 550px;
}
</style>
